<?php

//FIXME : cette classe gnre une cinquante de requetes inutile ....
//gros potentiel pour acclerer le logiciel (EP)


require_once("DataObject.class.php");


//FIXME Les Module n'ont pas  tre dans la base de donnes ....
class Module extends DataObject {
	
	
	//Ajout par EP afin de ne pas avoir a cherch l'id du module dans la base ....
	const ACTES = 1;
	const HELIOS = 2;
	const MAIL = 3;
	
	
	
  protected $objectName = "modules";
  protected $prettyName = "Module";
  
  protected $name;
  protected $description;
  protected $menu_entry;
  protected $status;
  
  protected $dbFields = array( "name" => array( "descr" => "Nom du module", "type" => "isString", "mandatory" => true),
						 "description" => array( "descr" => "Description", "type" => "isString", "mandatory" => true),
						 "menu_entry" => array( "descr" => "Entre du menu", "type" => "isString", "mandatory" => true),
						 "status" => array( "descr" => "tat", "type" => "isInt", "mandatory" => true)
						 );

  private $moduleParams = null;
  
  /**
   * \brief Constructeur d'un module
   * \param id integer : Numro d'identifiant d'un module existant avec lequel initialiser l'objet
   */
  public function __construct($id = false) {
    parent::__construct($id);
  }

  /**
   * \brief Mthode d'initialisation du module d'aprs son nom
   * \param $name chane : Prcise le nom du module  initialiser
   * \return true si succs, false sinon
   */
  //FIXME : cette mthode fait deux requete alors qu'une seule est ncessaire
  public function initByName($name) {
    $sql = "SELECT id FROM modules WHERE name='" . $name . "'";

    $result = $this->db->select($sql);

    if (! $result->isError() && $result->num_row() == 1) {
	  $row = $result->get_next_row();
	  $this->id = $row["id"];

	  return $this->init();
    }

	return false;
  }

  /**
   * \brief Mthode qui dtermine si le module courant est actif
   * \return True si le module est actif, false sinon
   */
  public function isActive() {
	return (isset($this->status) && $this->status == 1);
  }

  /**
   * \brief Mthode d'enregistrement d'un modules dans la base de donnes
   * \param $validate boolen (optionnel) Prcise si la validation de l'entit doit avoir lieu (true par dfaut)
   * \return true si succs, false sinon
   */
  public function save($validate = true, $bouchon_4_strict_standard = true) {
    if (! ($sql = parent::save($validate, true))) {
	  return false;
	}
  	 
  	//echo $sql;
    //exit();
    if (! $this->db->begin()) {
      $this->errorMsg = "Erreur lors de l'initialisation de la transaction.";
      return false;
	}

    if (! $this->db->exec($sql)) {
      $this->errorMsg = "Erreur lors de la sauvegarde du module.";
	  $this->db->rollback();
      return false;
    }
    
    if (! $this->db->commit()) {
      $this->errorMsg = "Erreur lors de la validation de la transaction.";
	  $this->db->rollback();
      return false;
	}
    
    //! Traitement des paramtres du module
    $sql = "DELETE FROM modules_params WHERE module_id=" . $this->id;
    
    if (! $this->db->exec($sql)) {
      $this->errorMsg = "Erreur lors de la rinitialisation des paramtres du module.";
	  $this->db->rollback();
      return false;
    }
    
    if (count($this->moduleParams) > 0) {
	  reset($this->moduleParams);
	  foreach ($this->moduleParams as $param) {
	  	$sql = "INSERT INTO modules_params (module_id, name, value, description) VALUES(" . $this->id . ", '" . addslashes($param["name"]) . "','" . addslashes($param["value"]) . "','" . addslashes($param["description"]) . "')";
	  	if (! $this->db->exec($sql)) {
		  $this->errorMsg = "Erreur lors de la sauvegarde des paramtres du module.";
		  $this->db->rollback();
		  return false;
		}
	  }
    }
    return true;
  }


  /** 
   * \brief Mthode de suppression d'un module dans la base de donnes
   * \param $id (optionnel) : numro d'identifiant du module  supprimer
   * \return True en cas de succs, false sinon
   */
  public function delete($id = false) {
    // Efface l'entit spcifie par $id ou alors l'entit courante si pas d'id
    if (! $id) {
      if (isset($this->id) && ! empty($this->id)) {
		$id = $this->id;
      } else {
		$this->errorMsg = "Pas d'identifiant pour l'entit a supprimer";
		return false;
      }
    }

	if (! $this->db->begin()) {
      $this->errorMsg = "Erreur lors de l'initialisation de la transaction.";
      return false;
	}

	$sql = "DELETE FROM modules_params WHERE module_id=" . $id;

    if (! $this->db->exec($sql)) {
	  $this->errorMsg = "Erreur lors de la suppression des associations avec les modules.";
	  $this->db->rollback();
	  return false;
    }
    
    $sql = "DELETE FROM modules_authorities WHERE module_id=" . $id;

    if (! $this->db->exec($sql)) {
	  $this->errorMsg = "Erreur lors de la suppression des associations avec les modules.";
	  $this->db->rollback();
	  return false;
    }
    
    $sql = "DELETE FROM users_perms WHERE module_id=" . $id;

    if (! $this->db->exec($sql)) {
	  $this->errorMsg = "Erreur lors de la suppression des associations avec les modules.";
	  $this->db->rollback();
	  return false;
    }
    
	if (! parent::delete($id)) {
	  $this->db->rollback();
      return false;
	}

	if (! $this->db->commit()) {
      $this->errorMsg = "Erreur lors de la validation de la transaction.";
	  $this->db->rollback();
      return false;
	}

	return true;
  }

  /** 
   * \brief Mthode renvoyant les paramtres du module
   * \return Un tableau contenant les paramtres pour le module courant
   */
  public function getModuleParams() {
  	$sql = "SELECT modules_params.id, modules_params.name, modules_params.value, modules_params.description FROM modules_params WHERE modules_params.module_id=" . $this->id;
  	
  	$result = $this->db->select($sql);
  	
  	if (! $result->isError()) {
  	  return $result->get_all_rows();
  	}
  	
  	return array();
   }

  /** 
   * \brief Mthode renvoyant la valeur d'un paramtre du module
   * \param $name chane : nom du paramtre dont rcuprer la valeur
   * \return La valeur du paramtre ou null si le paramtre n'existe pas
   */
  public function getParam($name) {
	if (! empty($name)) {
	  $sql = "SELECT modules_params.value FROM modules_params WHERE modules_params.name='" . $name . "' AND modules_params.module_id=" . $this->id;
  	
	  $result = $this->db->select($sql);
  	
	  if (! $result->isError() && $result->num_row() == 1) {
		$row = $result->get_next_row();
		return $row["value"];
	  }
	}

	return null;
   }

  /** 
   * \brief Mthode renvoyant l'ensemble des utilisateurs d'un module (ayant au moins la permission lecture seule sur le module)
   * \return Un tableau associatif des utilisateurs du module
   */
  public function getUsers() {
	$users = array();

	if (! empty($this->id)) {
	  $sql = "SELECT DISTINCT users.id, users.givenname, users.name, users.email FROM users LEFT JOIN users_perms ON users.id=users_perms.user_id LEFT JOIN modules ON users_perms.module_id=modules.id WHERE modules.id=" . $this->id . " AND (users_perms.perm='RO' OR users_perms.perm='RW') AND users.status=1";
  	
	  $result = $this->db->select($sql);
   

	  if (! $result->isError() && $result->num_row() > 0) {
		$users = $result->get_all_rows();
	  }
	}

	return $users;
  }

  /** 
   * \brief Mthode qui permet de fixer le paramtre d'un module
   * \param $name : nom du module
   * \param $description : description du module
   * \param $value : valeur du module
   */
  public function setModuleParams($name, $description, $value) {
	  $this->moduleParams[] = array("name"=>$name,"description"=>$description,"value"=>$value);
  }

  /**********************/
  /* Mthodes statiques */
  /**********************/

  /** 
   * \brief Mthode renvoyant les modules autoriss pour une collectivit
   * \param $authority entier : Numro d'identifiant de la collectivit
   * \return Un tableau ayant pour clefs les identifiants des modules autoriss
   */
  public static function getModulesForAuthority($authority) {
    $sql = "SELECT modules_authorities.id, modules_authorities.module_id FROM modules_authorities LEFT JOIN modules ON modules_authorities.module_id=modules.id WHERE modules_authorities.authority_id=" . $authority . " AND modules.status=1";
    $db = DatabasePool::getInstance();

    $result = $db->select($sql);

	$modules = array();

    if (! $result->isError()) {
	  while ($row = $result->get_next_row()) {
		$modules[$row["module_id"]] = true;
	  }
    }

	return $modules;
  }

  /** 
   * \brief Mthode renvoyant les modules autoriss pour un utilisateur (lecture seule ou lecture/criture)
   * \param $user entier : Numro d'identifiant de l'utilisateur
   * \return Un tableau ayant pour clefs les identifiants des modules autoriss
   */
  public static function getModulesForUser($user) {
	$zeUser = new User($user);
	$zeUser->init();

	if ( $zeUser->isSuper()) {
		$modules = Module::getActiveModulesList();

	  foreach ($modules as $key => $val) {
		$perms[$val["id"]] = array("name" => $val["name"], "description" => $val["description"], "menu_entry" => $val["menu_entry"]);
	  }
	
	  return $perms;
	}
		
	$modules = Module::getModulesForAuthority($zeUser->get("authority_id"));

	$perms = array();

	foreach ($modules as $key => $val) {
		$zeMod = new Module($key);
		$zeMod->init();
		if ($zeUser->canAccess($zeMod->get('name'))) {
		  $perms[$key] = array("name" => $zeMod->get("name"), 
		  					"description" => $zeMod->get("description"), 
		  					"menu_entry" => $zeMod->get("menu_entry"));
		}
	}

	return $perms;
  }

  /**
   * \brief Mthode d'obtention d'une liste des noms de modules actifs
   * \return tableau des noms de modules
   *
   * Cette mhode retourne un tableau dont les clefs sont les noms
   * des modules et le contenu de la case est le nom du module
  */
  public static function getActiveModulesNames() {
	$modules = Module::getActiveModulesList();

	$ret = array();
	foreach ($modules as $module) {
	  $ret[$module["name"]] = $module["name"];
	}

	return $ret;
  }

  /**
   * \brief Mthode d'obtention d'une liste de modules actif
   * \return tableau de modules
   *
   * Cette mhode retourne un tableau dont les clefs sont les identifiants
   * des modules et le contenu de la case est le nom du module
  */
  public static function getActiveModulesIdName() {
	return Module::getModulesIdName(" WHERE status=1");
  }

  /**
   * \brief Mthode d'obtention d'une liste de modules
   * \param $cond chane (optionnel) : condition  appliquer sur la requte SQL 
   * \return tableau de modules
   *
   * Cette mhode retourne un tableau dont les clefs sont les identifiants
   * des modules et le contenu de la case est le nom du module
  */
  public static function getModulesIdName($cond = '') {
    $modules = Module::getModulesList($cond);

    $tabModules = array();
    foreach ($modules as $key => $module) {
      $tabModules[$module["id"]] = $module["name"];
    }

    return $tabModules;
  }

  /** 
   * \brief Mthode qui renvoie la liste des modules actifs
   * \return Un tableau contenant les donnes des modules actifs
   */
  public static function getActiveModulesList() {
	return Module::getModulesList(" WHERE status=1 ORDER BY id ASC");
  }

  /** 
   * \brief Mthode qui renvoie la liste des modules
   * \param $cond chane (optionnel) : condition  appliquer sur la requte SQL 
   * \return Un tableau contenant les donnes des modules
   */
  public static function getModulesList($cond = "") {
    $sql = "SELECT modules.id, modules.name, modules.description, modules.menu_entry, modules.status FROM modules " . $cond;

    $db = DatabasePool::getInstance();

    $result = $db->select($sql);

    $r = array();
    if (! $result->isError()) {
      $r = $result->get_all_rows();
    }
    foreach($r as $i => $module){
    	if (in_array($module['name'], array('actes','helios'))){
    		//TODO : revoir les profils avec PK, PEV et EP
    		//$specific_perms = array("CS" => "Crer et signer","TT"=>"Tltransmettre");
    		$specific_perms = array();
    	} else {
    		$specific_perms = array();
    	}
    	$r[$i]['specific_perms'] = $specific_perms;
    }
    

    return $r;
  }
}
