<?php

require_once(__DIR__."/../../../init/init.php");

$me = new User();

$api = Helpers::getVarFromPost("api");

function exitOrDisplayError($api,$erreur_msg,$location){
	if ($api){
		$jsonOutput = new JSONoutput();
		$jsonOutput->displayErrorAndExit($erreur_msg);
	} else {
		$_SESSION["error"] = $erreur_msg;
		header("Location: $location " );
		exit;
	}
}

if (! $me->authenticate()) {
	exitOrDisplayError($api,"chec de l'authentification",WEBSITE);
}

if (! $me->isAdmin()) {
	exitOrDisplayError($api,"Accs refus",WEBSITE_SSL);
}

$id = Helpers::getVarFromGet("id");

$him = new User();
$him->setId($id);
if (! $him->init()) {
	exitOrDisplayError($api,"Erreur lors de la modification de l'utilisateur",WEBSITE_SSL . "/admin/users/admin_users.php");
} else {
	if (! $me->canEditUser($id)) {
		exitOrDisplayError($api,"Accs refus pour la modification de cet utilisateur", WEBSITE_SSL . "/admin/users/admin_users.php");
	}
}

$userSQL = new UserSQL($sqlQuery);
$userSQL->deleteCertificateRGS2Etoiles($him->getId());


$msg = "Modification ";
$msg .= " de l'utilisateur " . $him->getPrettyName() . " (id=" . $him->getId() . "). Rsultat ok.";
if (! Log::newEntry(LOG_ISSUER_NAME, $msg, 1, false, $me->get("role"), false, $me)) {
	$msg .= "\nErreur de journalisation.";
}


if ($api){
	$jsonOutput = new JSONoutput();
	$jsonOutput->display(array('status'=>'ok','message'=>$msg,'id'=>$him->getId()));
} else {
	$_SESSION["error"] = nl2br($msg);
	Helpers::purgeTempSession();
	header("Location: " . WEBSITE_SSL . "/admin/users/admin_user_edit.php?id=" . $him->getId() );
}
