<?php

// Configuration
require_once("../../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');

// Instanciation du module courant
$module = new Module();
if (! $module->initByName("actes")) {
  $_SESSION["error"] = "Erreur d'initialisation du module";
  header("Location: " . WEBSITE_SSL);
  exit();
}

$me = new User();

if (! $me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit();
}

if ($me->isGroupAdminOrSuper() || ! $module->isActive()||!$me->checkDroit($module->get("name"),'CS')) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit();
}

if ($module->getParam("paper") == "on") {
  $_SESSION["error"] = "Mode &nbsp;papier&nbsp; actif. Accs interdit.";
  header("Location: " . WEBSITE_SSL . "/modules/actes/");
  exit();
}

$myAuthority = new Authority($me->get("authority_id"));

$doc = new HTMLLayout();

$js = <<<EOJS
<script type="text/javascript">
//<![CDATA[

var progress_bar = new Image();
progress_bar.src = "/custom/images/progress_bar.gif";

//]]>
</script>
EOJS;

$doc->addHeader($js);

$doc->addHeader("<script src=\"/javascript/validateform.js\" type=\"text/javascript\"></script>\n");

$doc->setTitle("Tedetis : Actes - Import d'une enveloppe");

$doc->openContainer();
$doc->openSideBar();
$doc->buildMenu($me);
$doc->closeSideBar();
$doc->openContent();

// Zone contenu
$html .= "<h1>ACTES - Dmatrialisation du contrle de lgalit</h1>\n";
$html .= "<p id=\"back-transaction-btn\"><a class=\"btn btn-default\" href=\"" . WEBSITE_SSL . "/modules/actes/\" class=\"bouton\">Retour liste transactions</a></p>\n";
$html .= "<h2>Import d'une enveloppe</h2>\n";
$html .= "<form class=\"form-horizontal import-file-form\" action=\"" . WEBSITE_SSL . "/modules/actes/actes_transac_submit.php\" method=\"post\" enctype=\"multipart/form-data\" onsubmit=\"javascript:if (validateForm('enveloppe', 'Fichier enveloppe', 'RisString')) {toggle_upload('form_progress', progress_bar); return true; } else { return false; }\">\n";
$html .= "<div class=\"form-group\">";
$html .= "<label for=\"enveloppe\" class=\"col-md-6 control-label\">Indiquez le fichier archive de l'enveloppe  importer (taille maximum ".ACTES_ARCHIVE_MAX_SIZE." octets)</label>\n";
$html .= "<div class=\"col-md-6\">";
$html .= "<input type=\"hidden\" name=\"MAX_FILE_SIZE\" value=\"".ACTES_ARCHIVE_MAX_SIZE."\" />\n";
$html .= "<input type=\"file\" id=\"enveloppe\" name=\"enveloppe\"/>";
$html .= "</div>\n";
$html .= "</div>\n";
$html .= "<div id=\"form_progress\" class=\"form-group\"><div class=\"col-md-2\"><button class=\"btn btn-primary\" type=\"submit\" value=\"\" />Importer l'enveloppe</button></div></div>\n";
$html .= "</form>\n";
$html .= "</div>\n";
$html .= "</div>\n";
$html .= "</div>\n";

$doc->addBody($html);

$doc->closeContent();
$doc->closeContainer();

$doc->buildFooter();

$doc->display();
