<?php


// Configuration
require_once("../../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');
require_once(SITEROOT . '/public.ssl/modules/helios/class/HeliosTransaction.class.php');

// Instanciation du module courant
$module = new Module();
if (! $module->initByName("helios")) {
  $_SESSION["error"] = "Erreur d'initialisation du module";
  header("Location: " . WEBSITE_SSL);
  exit();
}

$me = new User();

if (! $me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit();
}

if (! $module->isActive() || ! $me->canAccess($module->get("name"))) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit();
}

$myAuthority = new Authority($me->get("authority_id"));


// Rcupration de la liste des enveloppes en fonction de l'utilisateur en cours

if ($me->isAuthorityAdmin()) {
  $author_filter= "AND users.authority_id=" . $me->get("authority_id");;
}
//---- corrige bug 209 par TAN
// ajoute le statistique de group admin
elseif($me->isGroupAdmin())
{
  $author_filter=" AND users.authority_group_id=".$me->get("authority_group_id");
}
//-----
 elseif (! $me->isAdmin()) {
  $author_filter = " AND users.id=" . $me->getId();
}

// Transactions depuis toujours
$allTrans= HeliosTransaction::countTransactions($author_filter);
$allTransmitted = HeliosTransaction::countTransactions($author_filter,true);
$allVol = HeliosTransaction::countTransactionVol($author_filter);
$allVolTransmitted =  HeliosTransaction::countTransactionVol($author_filter,true);

// Transactions du mois
$monthTrans = HeliosTransaction::countTransactions($author_filter,false,true);
$monthTransmitted = HeliosTransaction::countTransactions($author_filter,true,true);
$monthVol = HeliosTransaction::countTransactionVol($author_filter,false,true);
$monthVolTransmitted= HeliosTransaction::countTransactionVol($author_filter,true,true);

// transactions de l'anne
$yearTrans = HeliosTransaction::countTransactions($author_filter,false,false,true);
$yearTransmitted = HeliosTransaction::countTransactions($author_filter,true,false,true);
$yearVol = HeliosTransaction::countTransactionVol($author_filter,false,false,true);
$yearVolTransmitted = HeliosTransaction::countTransactionVol($author_filter,true,false,true);

$doc = new HTMLLayout();

$doc->setTitle("Tedetis : Hlios - Statistiques");

$doc->openContainer();
$doc->openSideBar();
$doc->buildMenu($me);
$doc->closeSideBar();
$doc->openContent();

$html = "<h1>HELIOS - Dmatrialisation de documents financiers</h1>\n";
$html .= "<h2>Statistiques des transactions Hlios";

if ($me->isSuper()) 
{
		$html .= " pour l'ensemble des collectivits/utilisateurs";
} 
elseif ($me->isAuthorityAdmin()) 
{
  	$html .= " pour la collectivit " . $myAuthority->get("name");
} 
elseif ($me->isGroupAdmin())
{
    $TempGroup=new Group($me->get("authority_group_id"));
    $TempGroup->init();
		$html .="pour le Group ".$TempGroup->get("name");
}
else 
{
  $html .= " pour l'utilisateur " . $me->getPrettyName();
}

$html .= "</h2>\n";
$html .= "<div class=\"list_form\">\n";
$html .= " <dl>\n";
$html .= "  <dt>Depuis le dbut du mois&nbsp;:</dt>\n";
$html .= "   <dd><ul>\n";
$html .= "    <li>Nombre de transaction postes sur le tdt&nbsp;: " . $monthTrans . "</li>\n";
$html .= "    <li>Nombre de transaction transmises  Hlios&nbsp;: " .$monthTransmitted . "</li>\n";
$html .= "    <li>Volume des transactions postes sur le tdt&nbsp;: " .$monthVol. " octets</li>\n";
$html .= "    <li>Volume des transactions transmises  Hlios&nbsp;: " . $monthVolTransmitted. " octets</li>\n";
$html .= "   </ul></dd>\n";
$html .= "  <dt>Depuis le dbut de l'anne&nbsp;:</dt>\n";
$html .= "   <dd><ul>\n";
$html .= "    <li>Nombre de transaction postes sur le tdt&nbsp;: " . $yearTrans . "</li>\n";
$html .= "    <li>Nombre de transaction transmises  Hlios&nbsp;: " .$yearTransmitted . "</li>\n";
$html .= "    <li>Volume des transactions postes sur le tdt&nbsp;: " .$yearVol. " octets</li>\n";
$html .= "    <li>Volume des transactions transmises  Hlios&nbsp;: " . $yearVolTransmitted. " octets</li>\n";
$html .= "   </ul></dd>\n";
$html .= "  <dt>En totalit&nbsp;:</dt>\n";
$html .= "   <dd><ul>\n";
$html .= "    <li>Nombre de transaction postes sur le tdt&nbsp;: " .$allTrans . "</li>\n";
$html .= "    <li>Nombre de transaction transmises  Hlios&nbsp;: " .$allTransmitted . "</li>\n";
$html .= "    <li>Volume des transactions postes sur le tdt&nbsp;: " .$allVol. " octets</li>\n";
$html .= "    <li>Volume des transactions transmises  Hlios&nbsp;: " .$allVolTransmitted." octets</li>\n";
$html .= "   </ul></dd>\n";
$html .= " </dl>\n";
$html .= "</div>\n";
$html .= "</div>\n";


$doc->addBody($html);

$doc->closeContent();
$doc->closeContainer();

$doc->buildFooter();

$doc->display();
?>