<?php
/*
 * TDTIS - Copyright 2006 Alternance-Soft
 * Contributeur : Jrme Schell, Aot 2006 
 *
 * contact@alternancesoft.com
 *
 * Ce logiciel est un programme informatique servant   la
 * dmatrialisation de l'administration. 
 *
 * Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilit au code source et des droits de copie,
 * de modification et de redistribution accords par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
 * seule une responsabilit restreinte pse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concdants successifs.
 *
 * A cet gard  l'attention de l'utilisateur est attire sur les risques
 * associs au chargement,    l'utilisation,    la modification et/ou au
 * dveloppement et   la reproduction du logiciel par l'utilisateur tant 
 * donn sa spcificit de logiciel libre, qui peut le rendre complexe   
 * manipuler et qui le rserve donc   des dveloppeurs et des professionnels
 * avertis possdant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invits   charger  et  tester  l'adquation  du
 * logiciel   leurs besoins dans des conditions permettant d'assurer la
 * scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 *  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
 *
 * Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
 * pris connaissance de la licence CeCILL, et que vous en avez accept les
 * termes.
*/
?>
<?php
/**
 * \file admin_send_global_message.php
 * \brief Page d'envoi massif de mails
 * \author Jrme Schell <j.schell@alternancesoft.com>
 * \date 22.08.2006
 * 
 *
 * Cette page envoie un message au utilisateur d'un module.
 *
 * Modifications :
 * Auteur   Date       Commentaire
 *
 */


// Configuration
require_once("../../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');
require_once(SITEROOT . '/class/Mailer.class.php');

$me = new User();

if (! $me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit();
}

if (! $me->isSuper()) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit();
}

$moduleId = Helpers::getVarFromPost("module");
$subject = Helpers::getVarFromPost("subject");
$body = Helpers::getVarFromPost("body");

if (empty($subject) || empty($body)) {
  $_SESSION["error"] = "Donnes manquantes pour l'envoi du message.";
  header("Location: " . WEBSITE_SSL . "/admin/utilities/");
  exit();
}

if (! empty($moduleId)) {
  $module = new Module($moduleId);
  if (! $module->init()) {
	$_SESSION["error"] = "Module incorrect spcifi.";
	header("Location: " . WEBSITE_SSL . "/admin/utilities/");
	exit();
  }
} else {
  $_SESSION["error"] = "Pas de module spcifi.";
  header("Location: " . WEBSITE_SSL . "/admin/utilities/");
  exit();
}

// Rcupration des destinataires du message
// (tous les utilisateurs du module concern)
if (! $recipients = $module->getUsers()) {
  $_SESSION["error"] = "Rcupration destinataire impossible.<br />" . $module->getErrorMsg();
  header("Location: " . WEBSITE_SSL . "/admin/utilities/");
  exit();
}

foreach($recipients as $recipient){
	$mailer = new Mailer();
	$mailer->addComplexRecipient($recipient); 

	if (! $mailer->sendMail($subject, $body)) {
	  $msg = "Erreur lors de l'envoi de message a " . $recipient['email'] . " utilisateurs du module " . $module->get("name") . ".\n";
	  $msg .= $mailer->getLastError();
	  $status = 3;
	}
}

$msg = "Envoi de message aux " . count($recipients) . " utilisateurs du module " . $module->get("name") . ". Rsultat ok.";
$status = 1;


if (! Log::newEntry(LOG_ISSUER_NAME, $msg, $status, false, 'SADM', $module->get("name"), $me)) {
  $msg .= "\nErreur de journalisation.";
}

$_SESSION["error"] = nl2br($msg);

header("Location: " . WEBSITE_SSL . "/admin/utilities/");
?>