<?php
/*
 * TDTIS - Copyright 2006 Alternance-Soft
 * Contributeur : Jrme Schell, Aot 2006 
 *
 * contact@alternancesoft.com
 *
 * Ce logiciel est un programme informatique servant   la
 * dmatrialisation de l'administration. 
 *
 * Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilit au code source et des droits de copie,
 * de modification et de redistribution accords par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
 * seule une responsabilit restreinte pse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concdants successifs.
 *
 * A cet gard  l'attention de l'utilisateur est attire sur les risques
 * associs au chargement,    l'utilisation,    la modification et/ou au
 * dveloppement et   la reproduction du logiciel par l'utilisateur tant 
 * donn sa spcificit de logiciel libre, qui peut le rendre complexe   
 * manipuler et qui le rserve donc   des dveloppeurs et des professionnels
 * avertis possdant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invits   charger  et  tester  l'adquation  du
 * logiciel   leurs besoins dans des conditions permettant d'assurer la
 * scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 *  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
 *
 * Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
 * pris connaissance de la licence CeCILL, et que vous en avez accept les
 * termes.
*/
?>
<?php
/**
 * \file logs_get_timestamp.php
 * \brief Page de tlchargement de l'entre de logs accompagne de son horodatage
 * \author Jrme Schell <j.schell@alternancesoft.com>
 * \date 21.08.2006
 * 
 *
 * Ce script permet de tlcharger une archive zip contenant l'entre de journal
 * accompagne de son fichier d'horodatage.
 *
 * Modifications :
 * Auteur   Date       Commentaire
 *
 */

// Configuration
require_once("../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');

$me = new User();

if (! $me->authenticate()) {
  $_SESSION["error"] = "chec de l'authentification";
  header("Location: " . WEBSITE);
  exit();
}

$id = Helpers::getVarFromGet("id");

$myAuthority = new Authority($me->get("authority_id"));

$log = new Log();

if (isset($id) && ! empty($id)) {
  $log->setId($id);
  if (! $log->init()) {
    $_SESSION["error"] = "Erreur lors de l'initialisation de l'entre de journal.";
    header("Location: " . WEBSITE_SSL . "/common/logs_view.php");
    exit();
  }
} else {
  $_SESSION["error"] = "Pas d'identifiant de log spcifi.";
  header("Location: " . WEBSITE_SSL . "/common/logs_view.php");
  exit();
}

// Vrification des permissions sur l'entre de journal
if (! $log->canView($me)) {
  $_SESSION["error"] = "Accs refus.";
  header("Location: " . WEBSITE_SSL . "/common/logs_view.php");
  exit();
}

if (! $log->sendArchive()) {
  $_SESSION["error"] = "Erreur de rcupration de l'entre de log et de son horodatage.<br />" . $log->getErrorMsg();
  header("Location: " . WEBSITE_SSL . "/common/logs_view.php");
}

exit();
?>
