<?php
/*
 * TDTIS - Copyright 2006 Alternance-Soft
 * Contributeur : Jrme Schell, Aot 2006 
 *
 * contact@alternancesoft.com
 *
 * Ce logiciel est un programme informatique servant  la
 * dmatrialisation de l'administration. 
 *
 * Ce logiciel est rgi par la licence CeCILL soumise au droit franais et
 * respectant les principes de diffusion des logiciels libres. Vous pouvez
 * utiliser, modifier et/ou redistribuer ce programme sous les conditions
 * de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA 
 * sur le site "http://www.cecill.info".
 *
 * En contrepartie de l'accessibilit au code source et des droits de copie,
 * de modification et de redistribution accords par cette licence, il n'est
 * offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons,
 * seule une responsabilit restreinte pse sur l'auteur du programme,  le
 * titulaire des droits patrimoniaux et les concdants successifs.
 *
 * A cet gard  l'attention de l'utilisateur est attire sur les risques
 * associs au chargement,   l'utilisation,   la modification et/ou au
 * dveloppement et  la reproduction du logiciel par l'utilisateur tant 
 * donn sa spcificit de logiciel libre, qui peut le rendre complexe  
 * manipuler et qui le rserve donc  des dveloppeurs et des professionnels
 * avertis possdant  des  connaissances  informatiques approfondies.  Les
 * utilisateurs sont donc invits  charger  et  tester  l'adquation  du
 * logiciel  leurs besoins dans des conditions permettant d'assurer la
 * scurit de leurs systmes et ou de leurs donnes et, plus gnralement, 
 *  l'utiliser et l'exploiter dans les mmes conditions de scurit. 
 *
 * Le fait que vous puissiez accder  cet en-tte signifie que vous avez 
 * pris connaissance de la licence CeCILL, et que vous en avez accept les
 * termes.
*/
?>
<?php
/**
 * \file actes_transac_show.php
 * \brief Page d'affichage d'une transaction Actes
 * \author Jrme Schell <j.schell@alternancesoft.com>
 * \date 27.07.2006
 * 
 *
 * Cette page affiche les dtails d'une transaction Actes et 
 * permet de demander son annulation et de la valider
 *
 * Modifications :
 * Auteur   Date       Commentaire
 *
 */

// Configuration
require_once("../../../config/config.php");
require_once(SITEROOT . '/class/include.class.php');
require_once(SITEROOT . '/public.ssl/modules/etat_civil/class/etat_civilTransaction.class.php');
require_once(SITEROOT . '/public.ssl/modules/etat_civil/class/etat_civilTransactionWorkflow.class.php');


// Instanciation du module courant
$module = new Module();
if (! $module->initByName("etat_civil")) {
  $_SESSION["error"] = "Erreur d'initialisation du module";
  header("Location: " . WEBSITE_SSL);
  exit();
}

$me = new User();

if (! $me->authenticate()) {
  $_SESSION["error"] = "hec de l'authentification";
  header("Location: " . WEBSITE);
  exit();
}

if (! $module->isActive()|| ! $me->canAccess($module->get("name"))) {
  $_SESSION["error"] = "Accs refus";
  header("Location: " . WEBSITE_SSL);
  exit();
}

$id = Helpers::getVarFromGet("id");



$myAuthority = new Authority($me->get("authority_id"));

//$transNatures = ActesTransaction::getTransactionNaturesIdDescr();

//$trans = new ActesTransaction();


$trans = new etat_civilTransaction();

if (isset($id) && ! empty($id)) {
  $trans->setId($id);
  if ($trans->init()) {//obtine inregistrarea ce corespunde 
	$owner = new User($trans->get("user_id")); //!!!!! din etat_civilTransaction
	$owner->init();
  } else {
	$_SESSION["error"] = "Erreur d'initialisation de la transaction.";
	header("Location: " . WEBSITE_SSL . "/modules/etat_civil/index.php");
	exit();
  }
} else {
  $_SESSION["error"] = "Pas d'identifiant de transaction spcifi";
  header("Location: " . WEBSITE_SSL . "/modules/etat_civil/index.php");
  exit();
}


// Vrification des permissions
if (! $me->isSuper()) {
  if (! ($me->isAuthorityAdmin() && $me->get("authority_id") == $owner->get("authority_id")) && ! ($me->getId() == $trans->get("user_id") && $me->canAccess($module->get("name")))) {
	$_SESSION["error"] = "Accs refus";
	header("Location: " . WEBSITE_SSL . "/modules/etat_civil/index.php");
	exit();
  }
}

$doc = new HTMLLayout();

$doc->setTitle("etat_civil : visualisation de transactions pour un fichier");

$doc->openContainer();
$doc->openSideBar();
$doc->buildMenu($me);
$doc->closeSideBar();
$doc->openContent();


$transStatus = $trans->getCurrentStatus(); //CURRENT STATUS


//$html .="id=".$id."<br>";

$html .= "<p id=\"back-transaction-btn\"><a href=\"" . WEBSITE_SSL . "/modules/etat_civil/\" class=\"btn btn-default\">Retour liste transactions</a></p>\n";
$html .= "<h2>Visualisation de transactions d'un fichier</h2>\n";
$html .= "<div class=\"data_table\">\n";
$html .= "<table class=\"data\">\n";
$html .= $doc->getHTMLArrayline("Fichier : ", $trans->getFilenameForID($id)); 
$html .= $doc->getHTMLArrayline("Date de postage :" ,Helpers :: getDateFromBDDDate(etat_civilTransactionWorkflow::getDatePoste($id), true));
$html .= $doc->getHTMLArrayline("Etat actuel :" ,etat_civilTransactionWorkflow::getCurrentStatus($id));
 
$url = "Non dfinie";
$html .= $doc->getHTMLArrayline("URL d'archivage", $url);
$html .= "</table>\n";
$html .= "</div>\n";
$html .= "<br />\n";

//Telecharger le fichier
//ToDo : actes_downloaf_file

//de lucrat...
$html .= "<h3>Rcuperation du fichier post ";
$html .= "<a href=\"" .WEBSITE_SSL. "/modules/etat_civil/etat_civil_download_file.php?id=" .$id. "\" title=\"Tlcharger le fichier\">".$trans->getFilenameForID($id)."</a> </h3>";

// Affichage du Workflow

$workflow = $trans->fetchWorkflow();
$status = etat_civilTransaction::getStatusList();

$html .= "<h3>Cycle de vie de la transaction</h3>\n";

if (count($workflow) > 0) {
  $html .= "<div class=\"data_table\">\n";
  $html .= "<table class=\"workflow_list\">\n";
  $html .= " <tr>\n";
  $html .= "  <th>tat</th>\n";
  $html .= "  <th>Date</th>\n";
  $html .= "  <th>Message</th>\n";
  $html .= " </tr>\n";

  foreach ($workflow as $stage) {
	$html .= " <tr>\n";
	$html .= "  <td>" . $status[$stage["status_id"]] . "</td>\n";
	$html .= "  <td>" . Helpers::getDateFromBDDDate($stage["date"], true) . "</td>\n";
	$html .= "  <td class=\"long_field\">" . nl2br(get_hecho($stage["message"])) . "</td>\n";
	$html .= " </tr>\n";
  }
  
  $html .= "</table>\n";
  $html .= "</div>\n";
} else {
  $html .= "Le cycle de vie est vide pour cette transaction.\n";
}


$html .= "</div>\n";

$doc->addBody($html);

$doc->closeContainer();

$doc->buildFooter();

$doc->display();

?>
